> ## Documentation Index
> Fetch the complete documentation index at: https://docs.getcarbon.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Webhook Events

> Retrieve the history of webhook events with pagination.

## Overview

This endpoint retrieves the history of webhook events with pagination.

### Request

**Method:** `GET`\
**URL:** `/v1/webhook/history`

#### Parameters

| Name           | In     | Type      | Required | Description                 |
| -------------- | ------ | --------- | -------- | --------------------------- |
| `x-carbon-key` | Header | `string`  | Yes      | API key for authentication. |
| `page`         | Query  | `integer` | No       | Page number for pagination. |
| `limit`        | Query  | `integer` | No       | Number of events per page.  |

### Response

**Status Code:** `200 OK`\
**Content-Type:** `application/json`

#### Example Response

```json theme={null}
{
  "status": "success",
  "message": "data fetched successfully",
  "data": [
    {
      "event_id": "REF-300102",
      "event_type": "account.incoming-transaction",
      "data": {
        "event": "account.incoming-transaction",
        "data": {
          "id": "fd2a1c7e-a17b-477b-8402-734967498369",
          "amount": 100000,
          "currency": "NGN",
          "transactionType": "CREDIT",
          "entryDate": "2024-12-16T13:51:52.759+0000",
          "uniqueRef": "REF-300102",
          "account": {
            "id": "a9a27820-c0d0-4e26-95e1-7625888e9fb9",
            "bankAccount": {
              "accountName": "CARBON BUSINESS DEMO - BRYANA HUELS",
              "accountNumber": "0000000000",
              "bank": {
                "code": "565",
                "name": "CARBON"
              }
            },
            "static": true,
            "currency": "NGN",
            "clientId": "251170382"
          }
        }
      },
      "created_at": "2024-12-16T15:06:13.000Z",
      "updated_at": "2024-12-16T15:06:13.000Z"
    },
    {
      "event_id": "REF-300102_CBN_STAMP_DUTY_CHARGE",
      "event_type": "account.outgoing-transaction",
      "data": {
        "event": "account.outgoing-transaction",
        "data": {
          "id": "d66a39f2-692c-4d19-8098-6bc45fd9f6bf",
          "amount": 50,
          "currency": "NGN",
          "transactionType": "DEBIT",
          "entryDate": "2024-12-16T13:51:55.156+0000",
          "uniqueRef": "REF-300102_CBN_STAMP_DUTY_CHARGE",
          "account": {
            "id": "a9a27820-c0d0-4e26-95e1-7625888e9fb9",
            "bankAccount": {
              "accountName": "CARBON BUSINESS DEMO - BRYANA HUELS",
              "accountNumber": "0000000000",
              "bank": {
                "code": "565",
                "name": "CARBON"
              }
            },
            "static": true,
            "currency": "NGN",
            "clientId": "251170382"
          }
        }
      },
      "created_at": "2024-12-16T14:52:15.000Z",
      "updated_at": "2024-12-16T14:52:15.000Z"
    }
  ],
  "total": 20
}
```


## OpenAPI

````yaml GET /v1/webhook/history
openapi: 3.0.0
info:
  title: Carbon Business API
  description: >-
    ## Welcome to our API Developer Documentation


    Carbon aims to unlock the full potential of your business with a
    feature-rich account designed for growth.


    ## Integrations


    We aim to provide our APIs for developers and businesses to offer financial
    services to their existing customer base through REST APIs without doing the
    heavy lifting. Our API has predictable resource-oriented URLs, accepts
    form-encoded request bodies, returns JSON-encoded responses, and uses
    standard HTTP response codes, authentication, and verbs.


    ### Authentication


    `Authorization : API Key`


    Header  

    `x-carbon-key : value`


    `x-carbon-key` can be generated via developer page on Carbon Business


    | Environment | URL |

    | --- | --- |

    | Live |  |

    | Sandbox |
    [https://carbonapistagingsecure.getcarbon.co/baas/api](https://carbonapistagingsecure.getcarbon.co/baas/api)
    |


    ### **Handling Errors**


    We use the conventional HTTP response codes to indicate the success or
    failure of an API request.  

    Codes in the 2xx range indicate success. Codes in the 4xx range indicate an
    error that failed given the information provided (e.g., a required parameter
    was omitted, etc.). Codes in the 5xx range indicate an error with our
    servers.


    | Error | Description |

    | --- | --- |

    | 400 - Bad Request | The request was unacceptable, often due to missing a
    required parameter. |

    | 401 - Unauthorized | Not a valid API key was provided. |

    | 402 - Request Failed | The parameters were valid but the request failed. |

    | 403 - Forbidden | The API key doesn't have permission to perform the
    request. |

    | 404 - Not Found | The requested resource doesn't exist. |

    | 429 - Too Many Requests | Too many requests hit the API |

    | 500, 502, 503, 504 - Server Errors | System Error |
  version: 1.0.0
servers:
  - url: https://carbonapistagingsecure.getcarbon.co/baas/api
    description: >-
      Replace {{base_url}} with your API base URL (e.g.,
      https://api.example.com)
security:
  - apikeyAuth: []
tags:
  - name: Accounts
    description: >-
      Virtual accounts are generated account details (account number and bank)
      that allow Carbon Business merchants to receive payments from customers
      via NGN bank transfer. This is currently only available in naira (NGN).


      Virtual accounts are either dynamic (temporary) or static (permanent). A
      dynamic account number expires after handling a transaction, while a
      static account number doesn't expire.


      **Static Account**


      Creating static accounts can be useful when receiving recurring payments
      through bank transfers. The process involves generating a static virtual
      account with customer information. Once payment is made, we will send you
      a webhook notification, which you can then manage.


      **Dynamic Account**


      Creating dynamic accounts can be useful when receiving one-time payments
      through bank transfers. The process involves generating a dynamic virtual
      account with a set amount for the customer during checkout. Once payment
      is made, we will send you a webhook notification, which you can then
      manage.


      Key things you can do with these endpoints:


      - Create an account

      - Retreive an account

      - Verify Transaction

      - Retreive a list of transactions
  - name: Accounts > Transactions
  - name: Banks
    description: |-
      - Get a list of banks and financial institutions
      - Verify/resolve account details
  - name: Customers
    description: >-
      This collection contains a set of API endpoints to manage customer-related
      operations for an application. The endpoints allow for creating a new
      customer, retrieving a list of all customers, and fetching details of a
      single customer.


      - Create Customer
          
      - Fetch Customer/Customers
  - name: Payout
    description: |-
      - Make Transfer
      - Verify Transfer
  - name: Status
    description: '- Service Health check'
  - name: Verification
  - name: Webhook
    description: |-
      ## EVENTS

      `account.incoming-transaction`

      ``` json
      {
          "event": "account.incoming-transaction",
          "data": {
              "id": "string",
              "amount": "float",
              "currency": "string",
              "transactionType": "string",
              "entryDate": "datetime",
              "uniqueRef": "string",
              "account": {
                  "id": "string",
                  "bankAccount": {
                      "accountName": "string",
                      "accountNumber": "string",
                      "bank": {
                          "code": "string",
                          "name": "string"
                      }
                  },
                  "static": boolean,
                  "currency": "string",
                  "clientId": "string"
              }
            }
      }

       ```

      `account.outgoing-transaction`

      ``` json
      {
          "event": "account.outgoing-transaction",
          "data": {
              "id": "string",
              "amount": "float",
              "currency": "string",
              "transactionType": "string",
              "entryDate": "datetime",
              "uniqueRef": "string",
              "account": {
                  "id": "string",
                  "bankAccount": {
                      "accountName": "string",
                      "accountNumber": "string",
                      "bank": {
                          "code": "string",
                          "name": "string"
                      }
                  },
                  "static": boolean,
                  "currency": "string",
                  "clientId": "string"
              }
          }
      }

       ```
  - name: Loans
    description: >-
      Partner lending API. Enables fintech partners to originate business loans
      for their end-customers.


      - Enroll customers for lending and trigger KYC

      - Submit loan applications and supporting documents

      - Manage offer acceptance, disbursement account, and post-offer steps

      - Charge repayments and retrieve repayment schedules
paths:
  /v1/webhook/history:
    get:
      tags:
        - Webhook
      summary: Webhook History
      description: >-
        This endpoint retrieves the webhook history with pagination. It returns
        a JSON response with a status, message, data array containing event
        details, and the total count of events.


        The response schema for this request can be documented as follows:


        ``` json

        {
            "type": "object",
            "properties": {
                "status": {"type": "string"},
                "message": {"type": "string"},
                "data": {
                    "type": "array",
                    "items": {
                        "type": "object",
                        "properties": {
                            "event_id": {"type": "string"},
                            "event_type": {"type": "string"},
                            "data": {
                                "type": "object",
                                "properties": {
                                    "event": {"type": "string"},
                                    "data": {
                                        "type": "object",
                                        "properties": {
                                            "id": {"type": "string"},
                                            "amount": {"type": "number"},
                                            "currency": {"type": "string"},
                                            "transactionType": {"type": "string"},
                                            "entryDate": {"type": "string"},
                                            "uniqueRef": {"type": "string"},
                                            "account": {
                                                "type": "object",
                                                "properties": {
                                                    "id": {"type": "string"},
                                                    "bankAccount": {
                                                        "type": "object",
                                                        "properties": {
                                                            "accountName": {"type": "string"},
                                                            "accountNumber": {"type": "string"},
                                                            "bank": {
                                                                "type": "object",
                                                                "properties": {
                                                                    "code": {"type": "string"},
                                                                    "name": {"type": "string"}
                                                                }
                                                            }
                                                        }
                                                    },
                                                    "static": {"type": "boolean"},
                                                    "currency": {"type": "string"},
                                                    "clientId": {"type": "string"}
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                            "created_at": {"type": "string"},
                            "updated_at": {"type": "string"}
                        }
                    }
                },
                "total": {"type": "number"}
            }
        }

         ```
      parameters:
        - name: x-carbon-key
          in: header
          schema:
            type: string
          required: true
          example: '{{access_token}}'
        - name: page
          in: query
          schema:
            type: integer
          example: '0'
        - name: limit
          in: query
          schema:
            type: integer
          example: '2'
      responses:
        '200':
          description: OK
          headers:
            Content-Security-Policy:
              schema:
                type: string
                example: >-
                  default-src 'self';base-uri 'self';font-src 'self' https:
                  data:;form-action 'self';frame-ancestors 'self';img-src 'self'
                  data:;object-src 'none';script-src 'self';script-src-attr
                  'none';style-src 'self' https:
                  'unsafe-inline';upgrade-insecure-requests
            Cross-Origin-Opener-Policy:
              schema:
                type: string
                example: same-origin
            Cross-Origin-Resource-Policy:
              schema:
                type: string
                example: same-origin
            Origin-Agent-Cluster:
              schema:
                type: string
                example: '?1'
            Referrer-Policy:
              schema:
                type: string
                example: no-referrer
            Strict-Transport-Security:
              schema:
                type: string
                example: max-age=15552000; includeSubDomains
            X-Content-Type-Options:
              schema:
                type: string
                example: nosniff
            X-DNS-Prefetch-Control:
              schema:
                type: string
                example: 'off'
            X-Download-Options:
              schema:
                type: string
                example: noopen
            X-Frame-Options:
              schema:
                type: string
                example: SAMEORIGIN
            X-Permitted-Cross-Domain-Policies:
              schema:
                type: string
                example: none
            X-XSS-Protection:
              schema:
                type: integer
                example: '0'
            RateLimit-Policy:
              schema:
                type: string
                example: 100;w=900
            RateLimit-Limit:
              schema:
                type: integer
                example: '100'
            RateLimit-Remaining:
              schema:
                type: integer
                example: '99'
            RateLimit-Reset:
              schema:
                type: integer
                example: '900'
            Content-Type:
              schema:
                type: string
                example: application/json; charset=utf-8
            Content-Length:
              schema:
                type: integer
                example: '1365'
            ETag:
              schema:
                type: string
                example: W/"555-ZrzVj02vbTHSeJxY9n6teGZLs4c"
            Date:
              schema:
                type: string
                example: Mon, 16 Dec 2024 15:01:06 GMT
            Connection:
              schema:
                type: string
                example: keep-alive
            Keep-Alive:
              schema:
                type: string
                example: timeout=5
          content:
            application/json:
              schema:
                type: object
              example:
                status: success
                message: data fetched successfully
                data:
                  - event_id: REF-300102
                    event_type: account.incoming-transaction
                    data:
                      event: account.incoming-transaction
                      data:
                        id: fd2a1c7e-a17b-477b-8402-734967498369
                        amount: 100000
                        currency: NGN
                        transactionType: CREDIT
                        entryDate: 2024-12-16T13:51:52.759+0000
                        uniqueRef: REF-300102
                        account:
                          id: a9a27820-c0d0-4e26-95e1-7625888e9fb9
                          bankAccount:
                            accountName: CARBON BUSINESS DEMO - BRYANA HUELS
                            accountNumber: '0000000000'
                            bank:
                              code: '565'
                              name: CARBON
                          static: true
                          currency: NGN
                          clientId: '251170382'
                    created_at: '2024-12-16T15:06:13.000Z'
                    updated_at: '2024-12-16T15:06:13.000Z'
                  - event_id: REF-300102_CBN_STAMP_DUTY_CHARGE
                    event_type: account.outgoing-transaction
                    data:
                      event: account.outgoing-transaction
                      data:
                        id: d66a39f2-692c-4d19-8098-6bc45fd9f6bf
                        amount: 50
                        currency: NGN
                        transactionType: DEBIT
                        entryDate: 2024-12-16T13:51:55.156+0000
                        uniqueRef: REF-300102_CBN_STAMP_DUTY_CHARGE
                        account:
                          id: a9a27820-c0d0-4e26-95e1-7625888e9fb9
                          bankAccount:
                            accountName: CARBON BUSINESS DEMO - BRYANA HUELS
                            accountNumber: '0000000000'
                            bank:
                              code: '565'
                              name: CARBON
                          static: true
                          currency: NGN
                          clientId: '251170382'
                    created_at: '2024-12-16T14:52:15.000Z'
                    updated_at: '2024-12-16T14:52:15.000Z'
                total: 20
components:
  securitySchemes:
    apikeyAuth:
      type: apiKey
      in: header
      name: apikey
      description: Provide your API key in the 'apikey' header.

````